SystemOrganization addCategory: #'GOODS-Protocol'!
SystemOrganization addCategory: #'GOODS-Metadata'!
SystemOrganization addCategory: #'GOODS-Cache'!
SystemOrganization addCategory: #'GOODS-Database'!
SystemOrganization addCategory: #'GOODS-Collections'!
SystemOrganization addCategory: #'GOODS-Test'!

Error subclass: #KKCommitFailure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

Object subclass: #KKDatabase
	instanceVariableNames: 'connection keyCache specialObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKDatabase methodsFor: 'private' stamp: 'avi 10/26/2003 15:52'!
withReadHandler: aBlock
	^ aBlock
		on: KKRequestObject
		do: [:n | n resume: (self objectForKey: n key)]! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:26'!
unlock: anObject
	connection unlockObject: (self keyForObject: anObject) completely: true! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:36'!
tryWriteLock: anObject
	^ connection lockObject: (self keyForObject: anObject) shared: false wait: false! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:26'!
writeLock: anObject do: aBlock
	self writeLock: anObject.
	^ aBlock ensure: [self unlock: anObject]! !

!KKDatabase methodsFor: 'private' stamp: 'avi 10/26/2003 15:18'!
withWriteHandler: aBlock
	^ aBlock
		on: KKRequestKey
		do: [:n | n resume: (self keyForObject: n object)]! !

!KKDatabase methodsFor: 'public' stamp: 'rbb 10/27/2003 17:36'!
logout
	connection logout.! !

!KKDatabase methodsFor: 'transactions' stamp: 'avi 10/26/2003 15:53'!
refresh
	self withReadHandler: [keyCache refresh]! !

!KKDatabase methodsFor: 'initializing' stamp: 'jrp 9/22/2004 11:44'!
initializeWithConnection: aConnection
	connection _ aConnection.
	keyCache _ KKKeyCache connection: aConnection.
	specialObjects _ IdentityDictionary new.
	specialObjects at: self put: -1.
	specialObjects at: ActiveWorld put: -2.! !

!KKDatabase methodsFor: 'private' stamp: 'avi 7/6/2004 12:06'!
objectForKey: key
	^ key > 0
		ifTrue: [keyCache at: key ifAbsent: [KKObjectProxy database: self key: key]]
		ifFalse: [specialObjects keyAtValue: key]! !

!KKDatabase methodsFor: 'accessing' stamp: 'avi 10/26/2003 16:19'!
root
	^ self withReadHandler: [keyCache root]! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:25'!
writeLock: anObject
	connection lockObject: (self keyForObject: anObject) shared: false wait: true! !

!KKDatabase methodsFor: 'transactions' stamp: 'avi 10/28/2003 00:18'!
rollback
	self withReadHandler: [keyCache rollback].
	self refresh.! !

!KKDatabase methodsFor: 'public' stamp: 'avi 2/28/2004 14:39'!
isConnected
	^ connection isConnected! !

!KKDatabase methodsFor: 'transactions' stamp: 'avi 10/28/2003 00:17'!
commitOnFailure: aBlock
	^ (self withWriteHandler: [keyCache commit])
		ifTrue: [self refresh]
		ifFalse: aBlock! !

!KKDatabase methodsFor: 'accessing' stamp: 'avi 11/8/2003 00:15'!
root: anObject
	self root.
	^ self withWriteHandler: [keyCache root: anObject]! !

!KKDatabase methodsFor: 'transactions' stamp: 'avi 1/27/2004 13:11'!
commitWithRetry: aBlock
	| val |
	val _ aBlock value. 
	self commitOnFailure: [self rollback. self commitWithRetry: aBlock].
	^ val.! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:26'!
readLock: anObject do: aBlock
	self readLock: anObject.
	^ aBlock ensure: [self unlock: anObject]! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:36'!
tryReadLock: anObject
	^ connection lockObject: (self keyForObject: anObject) shared: true wait: false! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:41'!
downgradeLock: anObject
	connection unlockObject: (self keyForObject: anObject) completely: false! !

!KKDatabase class methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 16:27'!
onHost: hostname port: aNumber
	^ self connection: (KKConnection hostname: hostname port: aNumber)! !

!KKDatabase methodsFor: 'private' stamp: 'avi 10/26/2003 15:52'!
at: key
	^ self withReadHandler: [keyCache at: key]! !

!KKDatabase methodsFor: 'caching' stamp: 'avi 10/27/2003 19:40'!
flush
	keyCache flushWithFullGC: false! !

!KKDatabase methodsFor: 'caching' stamp: 'avi 11/5/2003 18:48'!
cacheSize
	^ keyCache size! !

!KKDatabase class methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 15:02'!
connection: aConnection
	^ self basicNew initializeWithConnection: aConnection! !

!KKDatabase methodsFor: 'private' stamp: 'avi 7/6/2004 12:00'!
keyForObject: anObject
	^ anObject class == KKObjectProxy
		ifTrue: [anObject xxxKey]
		ifFalse: [specialObjects at: anObject ifAbsent: [keyCache keyForObject: anObject]]! !

!KKDatabase methodsFor: 'transactions' stamp: 'avi 10/28/2003 00:18'!
commit
	^ self commitOnFailure: [KKCommitFailure signal]! !

!KKDatabase methodsFor: 'locking' stamp: 'avi 10/26/2003 21:25'!
readLock: anObject
	connection lockObject: (self keyForObject: anObject) shared: true wait: true! !

!KKDatabase methodsFor: 'caching' stamp: 'avi 10/27/2003 19:40'!
flushAll
	keyCache flushWithFullGC: true! !

!Object class methodsFor: '*goods' stamp: 'AB 3/10/2002 17:39'!
goodsFieldDescriptorNamed: aName
	|selector|
	selector _ (aName, 'Descriptor') asSymbol.
	^ ((self respondsTo: selector)
			ifTrue: [self perform: selector]
			ifFalse: [KKSingleFieldContainer referenceField])
		name: aName! !

!Object class methodsFor: '*goods' stamp: 'jrp 9/27/2004 15:58'!
goodsFieldsToExclude

	^ #()! !

Object subclass: #KKCache
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

KKCache subclass: #KKClassCache
	instanceVariableNames: 'cache keys classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKClassCache methodsFor: 'public' stamp: 'avi 10/26/2003 20:10'!
classForObject: anObject
	^ classes
		ifNil: [self findClassForObject: anObject]
		ifNotNil: [classes at: anObject class ifAbsentPut: [self findClassForObject: anObject]]! !

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 22:58'!
loadDescriptorAt: aKey
	|descr|
	descr _ connection classAt: aKey.
	descr id: aKey.
	self at: aKey put: descr.
	^ descr! !

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 23:02'!
storeDescriptor: aClassDescriptor
	| id |
	id _ connection putClass: aClassDescriptor.
	aClassDescriptor id: id.
	self at: id put: aClassDescriptor.
	^ aClassDescriptor! !

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 22:40'!
at: aKey put: aClassDescriptor
	cache at: aKey put: aClassDescriptor.
	keys at: aClassDescriptor put: aKey.
	^ aClassDescriptor! !

!KKClassCache methodsFor: 'public' stamp: 'avi 10/26/2003 20:07'!
cacheClassesDuring: aBlock
	classes _ Dictionary new.
	^ aBlock ensure: [classes _ nil]! !

!KKClassCache methodsFor: 'initializing' stamp: 'avi 10/26/2003 12:57'!
initialize
	cache _ Dictionary new.
	keys _ Dictionary new! !

!KKClassCache methodsFor: 'private' stamp: 'AB 3/11/2002 22:58'!
at: aKey
	^ cache at: aKey ifAbsent: [self loadDescriptorAt: aKey]! !

!KKClassCache methodsFor: 'private' stamp: 'avi 10/26/2003 20:11'!
findClassForObject: anObject
	|descr storedDescr |
	descr _ anObject class goodsDescriptor.
	storedDescr _ (keys like: descr) ifNotNilDo: [:assoc | assoc key].
	^ storedDescr ifNil: [self storeDescriptor: descr]! !

KKCache subclass: #KKKeyCache
	instanceVariableNames: 'cache keys recordCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 14:58'!
at: key
	^ self at: key ifAbsent: [self loadObjectAt: key]! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 11/5/2003 18:48'!
size
	^ cache size! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 4/2/2004 16:20'!
commit
	^ recordCache commitObjects: cache! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/27/2003 19:55'!
flushWithFullGC: aBoolean
	| finalized |
	cache _ Dictionary new.
	aBoolean
		ifTrue: [Smalltalk garbageCollect]
		ifFalse: [Smalltalk garbageCollectMost].
	finalized _ OrderedCollection new.
	keys keysAndValuesDo:
		[:object :key |
		object
			ifNil: [finalized add: key]
			ifNotNil: [cache at: key put: object]].
	keys finalizeValues.
	connection forgetObjects: finalized.! !

!KKKeyCache methodsFor: 'private' stamp: 'avi 10/26/2003 14:59'!
at: key put: anObject
	cache at: key put: anObject.
	keys at: anObject put: key.! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 4/2/2004 16:07'!
root: anObject
	self at: self rootKey put: anObject! !

!KKKeyCache methodsFor: 'private' stamp: 'avi 10/31/2003 13:35'!
loadObjectAt: key
	^ recordCache
		loadObjectsStartingAt: key
		do: [:k :object | self refreshObjectAt: k from: object]
		ifAbsent: [nil]! !

!KKKeyCache methodsFor: 'private' stamp: 'avi 11/8/2003 00:44'!
refreshObjectAt: key from: anObject
	(cache includesKey: key)
		ifFalse: [self at: key put: anObject]
		ifTrue: [(cache at: key) copyFrom: anObject; goodsUpdate]! !

!KKKeyCache methodsFor: 'initializing' stamp: 'avi 2/27/2004 00:41'!
initialize
	recordCache _ KKRecordCache connection: connection.
	cache _ PluggableDictionary integerDictionary.
	keys _ WeakIdentityKeyDictionary new.! !

!KKKeyCache methodsFor: 'private' stamp: 'avi 10/26/2003 16:17'!
rootKey
	^ 16r10000! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 16:18'!
root
	^ self at: self rootKey! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 15:00'!
keyForObject: anObject
	| key |
	^ keys
		at: anObject
		ifAbsent:
			[key _ recordCache allocateObject: anObject.
			self at: key put: anObject.
			key]! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 14:58'!
at: key ifAbsent: aBlock
	^ cache at: key ifAbsent: aBlock! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 10/26/2003 17:02'!
refresh
	connection invalids ifNotNilDo: 
		[:invalids |
		invalids do: [:key | self loadObjectAt: key]]	! !

!KKKeyCache methodsFor: 'public' stamp: 'avi 4/3/2004 15:25'!
rollback
	cache keysAndValuesDo:
		[:key :object |
		recordCache objectForRecordAt: key ifPresent: 
			[:state |
			object copyFrom: state]]! !

!KKCache class methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 12:56'!
connection: aConnection
	^ self basicNew initializeWithConnection: aConnection! !

KKCache subclass: #KKRecordCache
	instanceVariableNames: 'cache newObjects classCache allocationCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKRecordCache methodsFor: 'public' stamp: 'avi 2/25/2004 01:42'!
allocateObject: anObject
	| descriptor |
	self addObject: anObject.
	descriptor _ classCache classForObject: anObject.
	^ allocationCache allocateObjectOfClass: descriptor id size: descriptor estimatedSize! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 4/13/2004 13:39'!
addNewObjectsToRecords: aCollection
	| new record |
	new _ newObjects.
	newObjects _ IdentitySet new.
	new do:
		[:ea |
		record _ self updateRecordForObject: ea.
		aCollection at: record key put: record]! !

!KKRecordCache methodsFor: 'public' stamp: 'avi 4/3/2004 15:18'!
loadObjectsStartingAt: aKey do: keyAndValueBlock ifAbsent: aBlock
	|records obj|
	records _ connection objectsAt: aKey copy: false cluster: true.
	records first classKey < 2 ifTrue: [^ aBlock value].
	
	self updateCacheFromRecords: records.
	
	records reverseDo:
		[:record |
		obj _ self loadObjectRecord: record.
		keyAndValueBlock value: record key value: obj].
	^ obj! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 10/26/2003 16:14'!
updateRecordForObject: anObject
	| descriptor stream|
	descriptor _ classCache classForObject: anObject.
	stream _ descriptor streamForObject: anObject.

	^ KKObjectRecord
			updateObjectAt: (self keyForObject: anObject)
			classKey: descriptor id
			data: stream contents
			unlock: true! !

!KKRecordCache methodsFor: 'public' stamp: 'avi 4/3/2004 15:24'!
objectForRecordAt: key ifPresent: aBlock
	cache at: key ifPresent: [:record | aBlock value: (self loadObjectRecord: record)]! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 10/26/2003 14:55'!
loadObjectRecord: aRecord
	^ (classCache at: aRecord classKey)
		objectFromStream: (ReadStream on: aRecord data)! !

!KKRecordCache methodsFor: 'public' stamp: 'avi 7/8/2004 11:28'!
commitObjects: aDictionary
	| dirtyRecords |
	classCache cacheClassesDuring:
		[dirtyRecords _ Dictionary new.
"		newObjects _ IdentitySet new."
		self addDirtyObjects: aDictionary toRecords: dirtyRecords.
		[newObjects isEmpty] whileFalse:
			[self addNewObjectsToRecords: dirtyRecords].
		allocationCache reloadCache.
		(connection commitRecords: dirtyRecords)
			ifTrue: [self updateCacheFromRecords: dirtyRecords. ^ true]
			ifFalse: [^ false]]! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 4/13/2004 13:38'!
addDirtyObjects: aDictionary toRecords: aCollection
	| newRec oldRec |
	aDictionary keysAndValuesDo:
		[:key :object |
		object goodsIsImmutable ifFalse:
			[newRec _ self updateRecordForObject: object.
			oldRec _ cache at: key ifAbsent: [].
			(oldRec notNil and: [newRec = oldRec]) ifFalse: [aCollection at: key put: newRec]]].
! !

!KKRecordCache methodsFor: 'initializing' stamp: 'avi 7/8/2004 11:24'!
initialize
	classCache _ KKClassCache connection: connection.
	allocationCache _ KKAllocationCache connection: connection.
	cache _ Dictionary new.
	newObjects _ IdentitySet new.! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 10/26/2003 14:36'!
keyForObject: anObject
	^ (KKRequestKey new object: anObject) signal! !

!KKRecordCache methodsFor: 'private' stamp: 'avi 4/3/2004 15:19'!
updateCacheFromRecords: aCollection
	aCollection do: [:ea | cache at: ea key put: ea]! !

!KKRecordCache methodsFor: 'public' stamp: 'avi 7/8/2004 11:25'!
addObject: anObject
	newObjects add: anObject! !

!KKCache methodsFor: 'initializing' stamp: 'avi 10/26/2003 12:57'!
initialize
	! !

!KKCache methodsFor: 'initializing' stamp: 'avi 10/26/2003 12:57'!
initializeWithConnection: aConnection
	connection _ aConnection.
	self initialize.! !

KKCache subclass: #KKAllocationCache
	instanceVariableNames: 'oids sizes cpids batchSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Cache'!

!KKAllocationCache methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 02:09'!
allocateObjectOfClass: aCPID size: aNumber
	oids isEmpty ifTrue: [self reloadCache].
	cpids add: aCPID.
	sizes add: aNumber.
	^ oids removeFirst! !

!KKAllocationCache methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 15:36'!
initialize
	oids _ OrderedCollection new.
	cpids _ OrderedCollection new.
	sizes _ OrderedCollection new.
	batchSize _ 50.! !

!KKAllocationCache methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 15:33'!
batchSize
	oids isEmpty ifTrue: [batchSize _ batchSize * 2].
	^ batchSize! !

!KKAllocationCache methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 15:28'!
reloadCache
	oids _ OrderedCollection withAll: (connection bulkAllocateSizes: sizes classes: cpids reserve: self batchSize).
	sizes _ OrderedCollection new.
	cpids _ OrderedCollection new.! !

Object subclass: #KKFieldContainer
	instanceVariableNames: 'fieldType name parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:00'!
booleanField
	^ self new fieldType: KKBooleanField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:55'!
charField
	^ self new fieldType: (KKUnsignedIntegerField new size: 2)! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:33'!
totalSize
	self subclassResponsibility! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
refreshObject: anObject fromStream: aStream
	self subclassResponsiblity ! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
floatField
	^ self new fieldType: KKFloatField new! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:55'!
longField
	^ self new fieldType: (KKSignedIntegerField new size: 8)! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:36'!
name: aName
	name _ aName! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:54'!
intField
	^ self new fieldType: (KKSignedIntegerField new size: 4)! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:51'!
hash
	^ name hash + self fieldSize + self components + self type! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:49'!
fieldSize
	^ fieldType size! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:43'!
fieldType
	^ fieldType! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:56'!
byteField
	^ self new fieldType: (KKSignedIntegerField new size: 1)! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
writeObject: anObject onStream: aStream
	self subclassResponsiblity ! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
doubleField
	^ self new fieldType: KKDoubleField new! !

KKFieldContainer subclass: #KKVariableFieldContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 15:27'!
refreshVariablePartOfObject: anObject fromStream: aStream
	1 to: anObject basicSize do:
		[:i | anObject basicAt: i put: (fieldType fieldFromStream: aStream)]! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:02'!
writeVariableArrayFrom: anObject onStream: aStream
	|array|
	array _ self fieldInObject: anObject.
	array do: [:each | fieldType writeField: each onStream: aStream].! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 9/22/2004 15:27'!
writeVariablePartOfObject: anObject onStream: aStream
	1 to: anObject basicSize do:
		[:i | fieldType writeField: (anObject basicAt: i) onStream: aStream]
! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 21:06'!
refreshObject: anObject fromStream: aStream
	anObject class isVariable
		ifTrue: [self refreshVariablePartOfObject: anObject fromStream: aStream]
		ifFalse: [self refreshVariableArrayInObject: anObject fromStream: aStream].
! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:38'!
components
	^ 0! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 21:06'!
writeObject: anObject onStream: aStream
	anObject class isVariable
		ifTrue: [self writeVariablePartOfObject: anObject onStream: aStream]
		ifFalse: [self writeVariableArrayFrom: anObject onStream: aStream]
! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:18'!
totalSize
	^ fieldType size! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:02'!
refreshVariableArrayInObject: anObject fromStream: aStream
	|size array |
	size _ ((aStream size - parent fixedSize) / fieldType size).
	array _ Array new: size.
	1 to: size do: [:i | array at: i put: (fieldType fieldFromStream: aStream)].
	self storeField: array inObject: anObject.! !

!KKVariableFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:38'!
isVariable
	^ true! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:16'!
fieldType: aType
	fieldType _ aType! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:59'!
referenceField
	^ self new fieldType: KKReferenceField new! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 21:06'!
storeField: aField inObject: anObject
	|i|
	i _ anObject class allInstVarNames indexOf: name.
	i > 0 ifTrue: [anObject instVarAt: i put: aField]! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:54'!
offsetToNextField
	^ 1! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 18:06'!
parent: aClassDescriptor
	parent _ aClassDescriptor! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:49'!
= other
	^ (((name = other name
		and: [self fieldSize = other fieldSize])
		and: [self components = other components])
		and: [self type = other type])! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:34'!
components
	self subclassResponsiblity ! !

KKFieldContainer subclass: #KKFixedArrayContainer
	instanceVariableNames: 'arraySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:58'!
writeObject: anObject onStream: aStream
	|array|
	array _ anObject instVarNamed: name.
	1 to: (array size min: arraySize) do:
		[:i | fieldType writeField: (array at: i) onStream: aStream].
	array size < arraySize
		ifTrue: [aStream next: (arraySize - array size) * fieldType size put: 0]			! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:58'!
refreshObject: anObject fromStream: aStream
	|array|
	array _ Array new: arraySize.
	1 to: arraySize do:
		[:i | array at: i put:
			(fieldType fieldFromStream: aStream)].
	anObject instVarNamed: name put: array.! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 01:00'!
components
	^ arraySize! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:02'!
arraySize: aNumber
	arraySize _ aNumber! !

!KKFixedArrayContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:17'!
totalSize
	^ arraySize * fieldType size! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 21:06'!
fieldInObject: anObject
	|i|
	i _ anObject class allInstVarNames indexOf: name.
	^ i > 0 ifTrue: [anObject instVarAt: i]! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:36'!
name
	^ name! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:16'!
isReference
	^ fieldType isReference! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:16'!
type
	^ fieldType type! !

KKFieldContainer subclass: #KKSingleFieldContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
refreshObject: anObject fromStream: aStream
	self storeField: (fieldType fieldFromStream: aStream) inObject: anObject! !

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:35'!
components
	^ 1! !

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:17'!
totalSize
	^ fieldType size! !

!KKSingleFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 23:21'!
stringField
	^ self new fieldType: KKStringField new! !

!KKSingleFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
writeObject: anObject onStream: aStream
	fieldType writeField: (self fieldInObject: anObject) onStream: aStream
				! !

!KKFieldContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 23:59'!
isVariable
	^ false! !

!KKFieldContainer class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:54'!
shortField
	^ self new fieldType: (KKSignedIntegerField new size: 2)! !

KKFieldContainer subclass: #KKStructureContainer
	instanceVariableNames: 'fieldCount size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 14:58'!
description
	^ Array with: (Array with: name with: #structure with: fieldCount)! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 00:53'!
fieldSize: aNumber
	size _ aNumber! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:51'!
components
	^ 1! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:53'!
isReference
	^ false! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
refreshObject: anObject fromStream: aStream
! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:58'!
totalSize
	^ 0! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
writeObject: anObject onStream: aStream
! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:50'!
fieldSize
	^ size ifNil: [size _ self calculateSize]
	 ! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:55'!
type
	^ 0! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 14:02'!
fieldCount: aNumber
	fieldCount _ aNumber! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 22:21'!
offsetToNextField
	^ fieldCount + 1! !

!KKStructureContainer methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:27'!
calculateSize
	|startIndex|
	startIndex _ parent fields identityIndexOf: self.
	^(parent fields copyFrom: startIndex to: startIndex + fieldCount)
		detectSum: [:each | each totalSize]! !

!Object class methodsFor: '*goods' stamp: 'AB 3/10/2002 21:40'!
goodsDescriptor
	|descriptor|
	descriptor _ self goodsDescriptorClass new.
	descriptor class: self;
				className: self goodsClassName.
	self goodsFieldDescriptors do: [:field | descriptor addField: field].
	self isVariable ifTrue: [descriptor addField: self goodsVariableFieldDescriptor].
	^ descriptor! !

!Object methodsFor: '*goods-override' stamp: 'avi 11/13/2003 17:26'!
= anObject 
	"Answer whether the receiver and the argument represent the same 
	object. If = is redefined in any subclass, consider also redefining the 
	message hash."

	^self == anObject yourself! !

!Object class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:04'!
goodsDescriptorClass
	^ self isVariable
		ifTrue: [KKVariableClassDescriptor]
		ifFalse: [KKClassDescriptor]! !

Object subclass: #KKClassDescriptor
	instanceVariableNames: 'class className fields id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKClassDescriptor class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 15:34'!
findClassForName: aClassName

	Object allSubclassesDoGently: [:class |
		((class respondsTo: #goodsClassName) and: [class goodsClassName = aClassName])
			ifTrue: [^ class]].

	^ Smalltalk
		at: (aClassName findTokens: '.') last asSymbol
		ifAbsent: [self error: 'Could not find class for ', aClassName].! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 20:21'!
objectFromStream: aStream
	|obj|
	obj _ self newInstanceFromStream: aStream.
	self referenceFieldsFirstDo: [:each | each refreshObject: obj fromStream: aStream].
	^ obj! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:42'!
= another
	^ className = another className and: [fields = another fields]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 20:21'!
writeObject: anObject onStream: aStream
	self referenceFieldsFirstDo: [:each | each writeObject: anObject onStream: aStream]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 18:07'!
addField: aFieldContainer
	self fields add: aFieldContainer.
	aFieldContainer parent: self.! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 20:19'!
streamForObject: anObject
	|stream|
	stream _ WriteStream on: (ByteArray new: 16).
	self writeObject: anObject onStream: stream.
	^ stream! !

!KKClassDescriptor class methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 15:33'!
forClassNamed: aClassName
	|class|
	class _ self findClassForName: aClassName.
	^ class goodsDescriptorClass new class: class; className: aClassName! !

KKClassDescriptor subclass: #KKVariableClassDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKVariableClassDescriptor subclass: #KKStringDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
objectFromStream: aStream
	^ (super objectFromStream: aStream) asString! !

!KKStringDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
writeObject: anObject onStream: aStream
	super writeObject: anObject asByteArray onStream: aStream! !

KKStringDescriptor subclass: #KKSymbolDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSymbolDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
objectFromStream: aStream
	^ (super objectFromStream: aStream) asSymbol! !

KKStringDescriptor subclass: #KKMetaclassDescriptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKMetaclassDescriptor methodsFor: 'as yet unclassified' stamp: 'rbb 8/5/2004 16:52'!
writeObject: aClass onStream: aStream
	super writeObject: aClass name onStream: aStream
! !

!KKMetaclassDescriptor methodsFor: 'as yet unclassified' stamp: 'rbb 8/5/2004 16:52'!
objectFromStream: aStream
	^ Smalltalk classNamed: (super objectFromStream: aStream)
! !

!KKStringDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:27'!
instanceClass
	^ ByteArray! !

!KKVariableClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:30'!
newInstanceFromStream: aStream
	^ self instanceClass basicNew: (aStream contents size - (self fixedSize)) / self varyingSize.! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:48'!
varyingRefs
	^ (fields select: [:f | f isVariable and: [f isReference]]) size! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:19'!
className
	^ className! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 20:22'!
referenceFieldsFirstDo: aBlock
	self fields do: [:ea | ea isReference ifTrue: [aBlock value: ea]].
	self fields do: [:ea | ea isReference ifFalse: [aBlock value: ea]]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:26'!
newInstanceFromStream: aStream
	^ self instanceClass basicNew! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 18:23'!
class: aClass
	class _ aClass.
! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 14:07'!
estimatedSize
	^ self fixedSize + (self varyingSize * 5)! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:19'!
className: aName
	className _ aName! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'rbb 8/6/2004 11:58'!
fixedSize
	^ (self fields reject: [:f | f isVariable]) detectSum: [:f | f totalSize]
! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 17:09'!
fields
	^ fields ifNil: [fields _ OrderedCollection new]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 15:26'!
instanceClass
	^ class! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 11:57'!
id: anID
	id _ anID! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 11:57'!
id
	^ id! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:53'!
fixedRefs
	^ (fields select: [:f | f isVariable not and: [f isReference]]) size! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 16:37'!
hash
	^ className hash + fields hash! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:51'!
varyingSize
	^ (fields select: [:f | f isVariable]) detectSum: [:f | f totalSize]! !

!KKClassDescriptor methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 17:10'!
referenceFieldsFirst
	^ (self fields select: [:f | f isReference]), (self fields reject: [:f | f isReference])! !

!Object class methodsFor: '*goods' stamp: 'jrp 9/27/2004 16:14'!
goodsFieldDescriptors
	|fields superFields ivars|
	ivars _ self instVarNames reject: [:each | self goodsFieldsToExclude includes: each].
	fields _ ivars collect: [:ivar | self goodsFieldDescriptorNamed: ivar].

	^ (self = Object or: [superclass = Object])
		ifTrue: [fields]
		ifFalse:
			[superFields _ self superclass goodsFieldDescriptors.
			(Array with: (KKStructureContainer new
								name: self superclass goodsClassName;
								fieldCount: superFields size)),
			superFields,
			fields]! !

!Object methodsFor: '*goods' stamp: 'avi 10/26/2003 21:07'!
yourClass
	^ self class! !

!Object methodsFor: '*goods' stamp: 'avi 2/27/2004 16:48'!
goodsIsImmutable
	^ false! !

!Object class methodsFor: '*goods' stamp: 'AB 3/11/2002 23:20'!
goodsVariableFieldDescriptor
	| container field |
	container _ KKVariableFieldContainer new name: 'array'.
	field _ self isBits
				ifFalse: [KKReferenceField new]
				ifTrue:
					[self isBytes
						ifTrue: [KKUnsignedIntegerField new size: 2]
						ifFalse: [KKUnsignedIntegerField new size: 4]].
	container fieldType: field.
	^ container
! !

!Object class methodsFor: '*goods' stamp: 'AB 3/11/2002 22:30'!
goodsClassName
	^ self name
! !

Object subclass: #KKFieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

KKFieldType subclass: #KKFloatField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:59'!
fieldFromStream: aStream
	^ Float fromIEEE32Bit: aStream uint32! !

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:59'!
writeField: aField onStream: aStream
	aStream uint32: aField asIEEE32BitWord ! !

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
size
	^ 4! !

!KKFloatField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:57'!
type
	^ 4! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 00:01'!
type
	self subclassResponsiblity ! !

KKFieldType subclass: #KKDoubleField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:40'!
size
	^ 8! !

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
fieldFromStream: aStream
	|float|
	float _ Float new: 2.
	float at: 1 put: aStream uint32.
	float at: 2 put: aStream uint32.
	^ float
! !

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:57'!
type
	^ 4! !

!KKDoubleField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:43'!
writeField: aField onStream: aStream
	aStream uint32: (aField at: 1).
	aStream uint32: (aField at: 2).
! !

KKFieldType subclass: #KKBlobField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKBlobField methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:19'!
type
	^ 6! !

!KKBlobField methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:19'!
isReference
	^ false! !

!KKBlobField methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:19'!
size
	^ 4! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:51'!
isReference
	^ false! !

KKFieldType subclass: #KKStringField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringField methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 14:36'!
fieldFromStream: aStream
	|length string|
	length _ aStream uint16.
	string _ String new: length.
	
	1 to: length do: [:i | string at: i put: (Character value: aStream uint16)].
	^ string! !

!KKStringField methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 23:17'!
size
	^ 2! !

!KKStringField methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 23:17'!
isReference
	^ false! !

!KKStringField methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 14:58'!
writeField: anObject onStream: aStream
	aStream uint16: anObject size.
	anObject do: [:char | aStream uint16: char asciiValue].! !

!KKStringField methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 23:17'!
type
	^ 5! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:26'!
offsetToNextField
	^ 1! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:20'!
fieldFromStream: aStream
	self subclassResponsibility ! !

!KKFieldType methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:58'!
writeField: aField onStream: aStream 
	self subclassResponsibility! !

KKFieldType subclass: #KKBooleanField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:42'!
writeField: aField onStream: aStream
	aStream boolean: aField! !

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:00'!
size
	^ 1! !

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:42'!
fieldFromStream: aStream
	^ aStream boolean! !

!KKBooleanField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 02:01'!
type
	^ 3! !

KKFieldType subclass: #KKReferenceField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKReferenceField commentStamp: 'avi 10/27/2003 15:56' prior: 0!
GOODS assumes that static type information is available, and so distinguishes between reference fields and immediate fields. In smalltalk, of course, the same field could hold a string one moment and an integer the next. To accomodate this, I've patched GOODS to support tagged pointers - the high bit of the reference field (actually of the storage id word of the reference field) is used to mark immediate values such as integers, floats, and booleans.

The patch is included in the class comment of KKReferenceField; after filing in the goods changeset, make sure you apply this patch to your GOODS installation.

If you already have GOODS installed, it isn't strictly necessary to apply this patch before trying out the Squeak interface - the goodsrv will work just fine without it until the first GC. At which point it will segfault.

This patch does have the side effect of reducing the maximum possible number of GOODS servers for a single database to around 32000. 32k should be enough for anyone.

For goods-2.71:

--- memmgr.cxx.orig	2002-10-16 10:05:02.000000000 -0700
+++ memmgr.cxx	2003-10-27 14:10:44.000000000 -0800
@@ -1270,11 +1270,13 @@
                 while (--n_refs >= 0) {
                     opid_t ropid;
                     stid_t rsid;
-                    p = unpackref(rsid, ropid, p);
+                p = unpackref(rsid, ropid, p);
+                if(!!(rsid & 0x8000)) {
                     assert(rsid < n_servers
                            && (ropid <= max_opid
                                || (ropid < last_opid && hp[ropid].is_free())));
                 }
+                }
             }
         }
     }
@@ -1705,6 +1707,7 @@
             GC_MARK(opid);
             gc_state |= gcs_cont;
         }
+    } else if (sid & 0x8000) { //tagged pointer
     } else {
         export_buffer* bp = &gc_export_buf[sid];
         opid_t* op = bp->refs;
--- objmgr.cxx.orig	2003-02-26 09:11:40.000000000 -0800
+++ objmgr.cxx	2003-10-27 14:10:44.000000000 -0800
@@ -626,7 +626,7 @@
                             continue;
                         }
                     }
-                    if (old_opid !!= 0) {
+                    if ((old_opid !!= 0) && !!(old_sid & 0x8000)) {
                         rp=rp->next=create_object_reference(old_sid, old_opid);
                     }
                 }
!

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 17:59'!
fieldFromStream: aStream
	|sid oid|
	sid _ aStream uint16.
	oid _ aStream uint32.

	^ (oid = 0 or: [(sid >> 15) = 1])
			ifTrue: [self fieldFromTag: sid value: oid]
			ifFalse: [self referenceAt: oid]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:05'!
referenceAt: aKey
	^ (KKRequestObject new key: aKey) signal! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 19:31'!
size
	^ 6! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'avi 10/28/2003 00:45'!
decodeUnsignedInteger: anInteger
	^ anInteger >= 16r80000000 
		ifTrue: [-16r1000000 + anInteger]
		ifFalse: [anInteger]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 19:30'!
type
	^ 1! !

KKReferenceField subclass: #KKStringArrayField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKStringArrayField methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:08'!
isReference
	^ false! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'avi 7/11/2004 11:59'!
fieldFromTag: sid value: oid
	^ sid = 0
		ifTrue: [nil]
		ifFalse: [(sid bitAnd: 16r00FF) caseOf:
					{[1] -> [self decodeUnsignedInteger: oid].
					 [2] -> [oid = 1].
					 [3] -> [Float fromIEEE32Bit: oid].
					 [4] -> [self referenceAt: oid * -1].
					 [5] -> [Character value: oid]}]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:05'!
keyForReference: anObject
	^ (KKRequestKey new object: anObject) signal! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'avi 10/31/2003 14:00'!
writeTaggedField: anObject onStream: aStream
	anObject
		ifNil: [aStream nextNumber: 6 put: 0]
		ifNotNil:
			[aStream nextPut: 255.
			 anObject goodsWriteTaggedOn: aStream].
! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:08'!
writeField: anObject onStream: aStream
	| oid sid |
	anObject goodsIsImmediateValue
		ifTrue: [self writeTaggedField: anObject onStream: aStream]
		ifFalse:
			[oid _ self keyForReference: anObject.
			oid < 0
				ifTrue: [sid _ 16rFF04. oid _ oid * -1]
				ifFalse: [sid _ 0].
			aStream
				uint16: sid;
				uint32: oid]! !

!KKReferenceField methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 21:51'!
isReference
	^ true! !

KKFieldType subclass: #KKUnsignedIntegerField
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
writeField: aField onStream: aStream
	aStream nextNumber: size put: aField! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:01'!
fieldFromStream: aStream
	^ aStream nextNumber: size! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:45'!
size: aNumber
	size _ aNumber! !

KKUnsignedIntegerField subclass: #KKSignedIntegerField
	instanceVariableNames: 'bitMask'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:58'!
type
	^ 2! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 11:25'!
encodeSignedInteger: aNumber
	^ aNumber < 0
		ifTrue: [(aNumber bitXor: bitMask) + 1]
		ifFalse: [aNumber]! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
writeField: aField onStream: aStream
	super writeField: (self encodeSignedInteger: aField) onStream: aStream! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 11:26'!
decodeSignedInteger: aNumber
	^ aNumber highBit = (size * 8)
		ifTrue: [((aNumber bitXor: bitMask) + 1) negated]
		ifFalse: [aNumber]! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 11:22'!
size: aNumber
	size _ aNumber.
	bitMask _ (2 raisedTo: size * 8) - 1.! !

!KKSignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:00'!
fieldFromStream: aStream
	^ self decodeSignedInteger: (super fieldFromStream: aStream)! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:45'!
size
	^ size! !

!KKUnsignedIntegerField methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 01:37'!
type
	^ 3! !

Object subclass: #KKFieldRecord
	instanceVariableNames: 'type size components index nextIndex name nameOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:31'!
initializeFromStream: aStream atIndex: anIndex
	type _ aStream uint16.
	nameOffset _ aStream uint16.
	size _ aStream uint32.
	components _ aStream uint32. 
	nextIndex _ aStream uint32.
	index _ anIndex.! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 11:47'!
name: aName
	name _ aName! !

!KKFieldRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:30'!
fromStream: aStream atIndex: anIndex
	^ self new initializeFromStream: aStream atIndex: anIndex! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 12:14'!
nameOffset: aNumber
	nameOffset _ aNumber! !

!KKFieldRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:27'!
fromDescriptor: aDescriptor atIndex: anIndex
	^ self new initializeFromDescriptor: aDescriptor atIndex: anIndex! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 12:14'!
name
	^ name! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'avi 2/26/2004 02:07'!
descriptor
	|fieldType container|
	type caseOf:
		{
			[0] -> [^ KKStructureContainer new
							name: name;
							fieldCount: (nextIndex - index) - 1;
							fieldSize: size].
			[1] -> [fieldType _ KKReferenceField new].
			[2] -> [fieldType _ KKSignedIntegerField new size: size].
			[3] -> [fieldType _ size = 1
								  ifTrue: [KKBooleanField new]
								  ifFalse: [KKUnsignedIntegerField new size: size]].
			[4] -> [fieldType _ size = 4
									ifTrue: [KKFloatField new]
									ifFalse: [KKDoubleField new]].
			[5] -> [fieldType _ KKStringField new].
			[6] -> [fieldType _ KKStringArrayField new].
		} otherwise: [self error: 'unknown field type'].
	container _ components caseOf:
				{
				[0] -> [KKVariableFieldContainer new].
				[1] -> [KKSingleFieldContainer new]
				} otherwise: [KKFixedArrayContainer new arraySize: components].
	container
		name: name;
		fieldType: fieldType.		
	^ container	! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 22:19'!
initializeFromDescriptor: aDescriptor atIndex: anIndex
	type _ aDescriptor type.
	size _ aDescriptor fieldSize.
	components _ aDescriptor components.
	name _ aDescriptor name.
	index _ anIndex.
	nextIndex _ anIndex + aDescriptor offsetToNextField ! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 15:32'!
writeOn: aStream
	aStream
		uint16: type;
		uint16: nameOffset;
		uint32: size;
		uint32: components;
		uint32: nextIndex.
! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:32'!
nextIndex
	^ nextIndex! !

!KKFieldRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 12:58'!
nextIndex: anIndex
	nextIndex _ anIndex! !

!Object methodsFor: '*goods' stamp: 'avi 11/8/2003 00:46'!
goodsUpdate
	! !

Object subclass: #KKConnection
	instanceVariableNames: 'socket headerBuf invalids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:17'!
putClass: aClassDescriptor
	|stream buffer|
	stream _ WriteStream on: (ByteArray new: 100).
	(KKClassRecord fromDescriptor: aClassDescriptor) writeOn: stream.
	buffer _ stream contents.
	
	self sendCommand: 7 withLong: buffer size.
	socket sendData: buffer.
		
	^ self receiveClassID! !

!KKConnection class methodsFor: 'as yet unclassified' stamp: 'avi 11/8/2003 00:16'!
hostname: hostname port: portNumber
	| socket |
	Socket initializeNetwork.
	socket _ (Socket newTCP
				connectTo: (NetNameResolver addressForName: hostname)
				port: portNumber).
	(Delay forMilliseconds: 10) wait.
	^ (self socket: socket) loginWithName: self defaultLogin; yourself! !

!KKConnection class methodsFor: 'as yet unclassified' stamp: 'avi 11/8/2003 00:16'!
defaultLogin
	^ 'squeak', (Time millisecondClockValue hex allButFirst: 3)! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:15'!
allocateObjectOfClass: aCPID size: aSize
	self sendCommand: 23
		withShort: aCPID
		withLong: aSize.
	^ self receiveLocation! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerLong
	^ headerBuf longAt: 5 bigEndian: true! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 00:10'!
receiveHeader
	self receiveIntoHeaderBuffer.
	self headerCommand = 4 ifTrue:
		[self receiveInvalids.
		 self receiveHeader]! !

!KKConnection methodsFor: 'private' stamp: 'avi 10/27/2003 18:49'!
forgetOrThrowObjects: aCollection withCommand: aCommand
	aCollection isEmpty ifTrue: [^ self].
	
	self sendCommand: aCommand
		withLong: aCollection first
		withLong: aCollection size - 1.
			
	aCollection allButFirst do:
		[:oid |
		self sendCommand: aCommand
			withLong: oid]! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:16'!
logout
	self sendCommand: 18.
	[self receiveHeader] on: Notification do: [^ true]! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:16'!
loginWithName: aName
	self sendCommand: 17
		withLong: aName size.
	socket sendData: aName.
	
	^ self receiveOkOrRefused! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 01:14'!
receiveLockResult
	self receiveHeader.
	self headerCommand = 11 ifFalse: [self error: 'Expecting lock result'].
	^ self headerByte = 1! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 2/28/2004 14:40'!
isConnected
	^ socket isValid and: [socket isConnected]! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 14:29'!
receiveTransactionResult
	self receiveHeader.
	self headerCommand = 15 ifFalse: [self error: 'Expecting transaction result'].
	^ self headerByte = 1! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 18:59'!
headerByte
	^ headerBuf at: 2 ! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 2/25/2004 01:53'!
bulkAllocateSizes: sizeArray classes: classArray reserve: aNumber
	| stream buffer |
	stream _ WriteStream on: (ByteArray new: 500).
	sizeArray do: [:ea | stream uint32: ea].
	classArray do: [:ea | stream uint16: ea].
	buffer _ stream contents.
	
	self sendCommand: 26
		withLong: sizeArray size
		withLong: aNumber.
	socket sendData: buffer.
	
	^ self receiveObjectIDs! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 01:17'!
receiveLocation
	self receiveHeader.
	self headerCommand = 24 ifFalse: [self error: 'Expecting object location'].
	^ self headerLong! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 00:12'!
receiveInvalids
	invalids ifNil: [invalids _ Set new].
	invalids add: self headerLong.
	self headerLong2 timesRepeat: [
		self receiveFullyInto: headerBuf.
		invalids add: self headerLong]
! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/27/2003 18:30'!
throwObjects: aCollection
	self forgetOrThrowObjects: aCollection withCommand: 3! !

!KKConnection methodsFor: 'client commands' stamp: 'AB 3/10/2002 01:07'!
forgetObjects: aCollection
	self forgetOrThrowObjects: aCollection withCommand: 2! !

!KKConnection methodsFor: 'private - receives' stamp: 'avi 2/25/2004 01:59'!
receiveObjectIDs
	| buffer readStream |
	self receiveHeader.
	self headerCommand = 27 ifFalse: [self error: 'Expected object ids'].
	buffer _ ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ Array streamContents:
		[:s |
		readStream _ buffer readStream.
		[readStream atEnd] whileFalse: [s nextPut: readStream uint32]]! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 18:34'!
sendCommand: aByte withLong: aLong
	self sendCommand: aByte
			withByte: 0
			withShort: 0
			withLong: aLong
			withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 22:37'!
sendCommand: aByte withShort: aShort withLong: aLong
	self sendCommand: aByte
			withByte: 0
			withShort: aShort
			withLong: aLong
			withLong: 0! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerShort
	^ headerBuf shortAt: 3 bigEndian: true! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/11/2002 02:01'!
receiveClassDescriptor
	|buffer|
	self receiveHeader.
	self headerCommand = 6 ifFalse: [self error: 'Expected class descriptor'].
	buffer _ ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ (KKClassRecord fromStream: (ReadStream on: buffer)) descriptor.! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 19:00'!
headerLong2
	^ headerBuf longAt: 9 bigEndian: true! !

!KKConnection methodsFor: 'private' stamp: 'avi 10/26/2003 21:14'!
initializeWithSocket: aSocket
	headerBuf _ ByteArray new: 16.
	socket _ aSocket.
! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:16'!
freeObject: oid
	self sendCommand: 25 withLong: oid! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 11:53'!
receiveObjectsFromStream: aStream
	|records|
	records _ OrderedCollection new.
	[aStream atEnd] whileFalse:
		[records add: (KKObjectRecord fromStream: aStream)].
	^ records! !

!KKConnection methodsFor: 'private - receives' stamp: 'avi 7/10/2004 01:59'!
receiveFullyInto: aBuffer
	|i size|
	i _ 1.
	size _ aBuffer size.
	[i > size] whileFalse:
		[self isConnected ifFalse: [self bye].
		i _ i + (socket receiveDataInto: aBuffer startingAt: i)].! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 11:24'!
receiveClassID
	self receiveHeader.
	self headerCommand = 8 ifFalse: [self error: 'Expected class id'].
	^ self headerShort! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/10/2002 01:19'!
sendCommand: aCommand
	self sendCommand: aCommand
		withByte: 0
		withShort: 0
		withLong: 0
		withLong: 0! !

!KKConnection methodsFor: 'private' stamp: 'rbb 10/31/2003 12:02'!
bye
	socket closeAndDestroy.
	self notify: 'GOODS server disconnected'.
	! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/7/2002 11:53'!
receiveObjects
	|buffer|
	self receiveHeader.
	self headerCommand = 1 ifFalse: [self error: 'Expecting object packet'].
	buffer _ ByteArray new: self headerLong.
	self receiveFullyInto: buffer.
	^ self receiveObjectsFromStream: (ReadStream on: buffer).
! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:15'!
commitRecords: objectRecords
	|stream buffer|
	objectRecords isEmpty ifTrue: [^ true].
	stream _ WriteStream on: (ByteArray new: 500).
	objectRecords do: [:each | each writeOn: stream].
	buffer _ stream contents.
	
	self sendCommand: 13
		withShort: 1
		withLong: buffer size.
	socket sendData: buffer.
	
	^ self receiveTransactionResult! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:16'!
invalids
	socket dataAvailable ifTrue:
		[self receiveIntoHeaderBuffer.
		self headerCommand = 4 ifFalse: [self error: 'Expecting invalidate'].
		self receiveInvalids].
		
	^ invalids ifNotNilDo: [:result | invalids _ nil. result]
! !

!KKConnection class methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 15:47'!
socket: aSocket
	^ self basicNew initializeWithSocket: aSocket! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:15'!
classAt: anID
	self sendCommand: 5 withShort: anID.
	^ self receiveClassDescriptor! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/10/2002 01:05'!
sendCommand: aByte withLong: aLong withLong: anotherLong
	self sendCommand: aByte
			withByte: 0
			withShort: 0
			withLong: aLong
			withLong: anotherLong! !

!KKConnection methodsFor: 'private' stamp: 'AB 3/6/2002 18:59'!
headerCommand
	^ headerBuf at: 1! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/6/2002 19:01'!
receiveOkOrRefused
	self receiveHeader.
	^ self headerCommand caseOf:
		{[21] -> [true].
		 [22] -> [false]}
		otherwise: [self error: 'Expected ok or refuse'].! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/6/2002 21:18'!
sendCommand: aByte withShort: aShort
	self sendCommand: aByte
			withByte: 0
			withShort: aShort
			withLong: 0
			withLong: 0! !

!KKConnection methodsFor: 'private - sends' stamp: 'AB 3/7/2002 11:39'!
sendCommand: aCommand withByte: aByte withShort: aShort withLong: aLong withLong: anotherLong
	headerBuf at: 1 put: aCommand.
	headerBuf at: 2 put: aByte.
	headerBuf shortAt: 3 put: aShort bigEndian: true.
	headerBuf longAt: 5 put: aLong bigEndian: true.
	headerBuf longAt: 9 put: anotherLong bigEndian: true.
	socket sendData: headerBuf.! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:17'!
objectsAt: oid copy: copyFlag cluster: clusterFlag
	self sendCommand: 0
		withShort: (copyFlag ifTrue: [1] ifFalse: [0]) + (clusterFlag ifTrue: [2] ifFalse: [0])
		withLong: oid.
		
	^ self receiveObjects! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:17'!
unlockObject: anID completely: aBoolean
	self sendCommand: 12
		withByte: (aBoolean ifTrue: [0] ifFalse: [1])
		withShort: 0
		withLong: anID
		withLong: 0! !

!KKConnection methodsFor: 'client commands' stamp: 'avi 10/26/2003 21:16'!
lockObject: anID shared: sharedFlag wait: waitFlag
	self sendCommand: 10
		withByte: (sharedFlag ifTrue: [1] ifFalse: [2])
		withShort: (waitFlag ifTrue: [0] ifFalse: [1])
		withLong: anID
		withLong: 0.
				
	^ self receiveLockResult! !

!KKConnection methodsFor: 'private - receives' stamp: 'AB 3/10/2002 00:10'!
receiveIntoHeaderBuffer
	self receiveFullyInto: headerBuf.
	self headerCommand = 20 ifTrue: [self bye].
! !

!Object methodsFor: '*goods' stamp: 'avi 2/27/2004 23:19'!
goodsIsImmediateValue
	^ false! !

Object subclass: #KKObjectRecord
	instanceVariableNames: 'txnFlags oid cpid storage data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKObjectRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 11:50'!
fromStream: aStream
	^ self new initializeFromStream: aStream! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 16:06'!
data
	^ data! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/13/2002 12:00'!
initializeWithKey: aKey classKey: aClassKey data: aByteArray txnFlags: aNumber
	oid _ aKey.
	cpid _ aClassKey.
	data _ aByteArray.
	txnFlags _ aNumber.
	storage _ 0.
! !

!KKObjectRecord class methodsFor: 'as yet unclassified' stamp: 'avi 10/28/2003 00:05'!
updateObjectAt: aKey classKey: aClassKey data: aByteArray unlock: aBoolean
	|flags|
	flags _ aBoolean ifTrue: [7] ifFalse: [3].
	^ self new initializeWithKey: aKey classKey: aClassKey data: aByteArray txnFlags: flags! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 15:32'!
writeOn: aStream
	aStream uint32: txnFlags.
	aStream uint32: oid.
	aStream uint16: cpid.
	aStream uint16: storage.
	aStream uint32: data size.
	aStream nextPutAll: data.! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/8/2002 16:06'!
classKey
	^ cpid! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 14:41'!
= other
	^ other key = oid
		and: [other classKey = cpid]
		and: [other data = data]! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/11/2002 13:29'!
key
	^ oid! !

!KKObjectRecord class methodsFor: 'as yet unclassified' stamp: 'avi 10/28/2003 00:06'!
validateObjectAt: aKey classKey: aClassKey unlock: aBoolean
	|flags|
	flags _ aBoolean ifTrue: [6] ifFalse: [2].
	^ self new initializeWithKey: aKey classKey: aClassKey data: #() txnFlags: flags! !

!KKObjectRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 15:31'!
initializeFromStream: aStream
	|size|
	txnFlags _ aStream uint32.
	oid _ aStream uint32.
	cpid _ aStream uint16.
	storage _ aStream uint16.
	size _ aStream uint32.
	
	data _ aStream next: size! !

Object subclass: #KKClassRecord
	instanceVariableNames: 'fixedSize varyingSize fixedRefs varyingRefs fields name nameSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Protocol'!

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 19:34'!
calculateNameOffsets
	|base i|
	base _ fields size * 16.
	i _ name size + 1.
	fields do:
		[:each |
		each nameOffset: base + i.
		i _ i + each name size + 1].
	nameSize _ i.
	! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 15:32'!
writeOn: aStream
	aStream uint32: fixedSize.
	aStream uint32: varyingSize.
	aStream uint32: fixedRefs.
	aStream uint32: varyingRefs.
	
	aStream uint32: fields size.
	aStream uint32: nameSize.
	fields do: [:each | each writeOn: aStream].
	aStream nextPutAll: name asByteArray; nextPut: 0.
	fields do: [:each | aStream nextPutAll: each name asByteArray; nextPut: 0].
	
! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 13:44'!
initializeFromStream: aStream
	| fieldCount |
	fixedSize _ aStream uint32.
	varyingSize _ aStream uint32.
	fixedRefs _ aStream uint32.
	varyingRefs _ aStream uint32.
	
	fieldCount _ aStream uint32.
	nameSize _  aStream uint32.

	fields _ Array new: fieldCount.
	1 to: fieldCount do: [:i |
		fields at: i put: (KKFieldRecord fromStream: aStream atIndex: i - 1)].
	
	name _ (aStream upTo: 0) asString.
	fields do: [:field | field name: (aStream upTo: 0) asString].! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/9/2002 18:23'!
descriptor
	|descr|
	descr _ KKClassDescriptor forClassNamed: name.
	fields do: [:each | descr addField: each descriptor].
	^ descr! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:32'!
fixIndices
	|indicesSeen|
	indicesSeen _ Set new.
	fields do:
		[:each | |index|
		index _ each nextIndex.
		((indicesSeen includes: index) or: [index >= fields size])
			ifTrue: [each nextIndex: 0].
		indicesSeen add: index].! !

!KKClassRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 19:25'!
fromDescriptor: aDescriptor
	^ self new initializeFromDescriptor: aDescriptor! !

!KKClassRecord class methodsFor: 'as yet unclassified' stamp: 'AB 3/7/2002 11:40'!
fromStream: aStream
	^ self new initializeFromStream: aStream! !

!KKClassRecord methodsFor: 'as yet unclassified' stamp: 'AB 3/10/2002 21:33'!
initializeFromDescriptor: aDescriptor
	fields _ aDescriptor fields collectWithIndex:
		[:each :i | (KKFieldRecord fromDescriptor: each atIndex: i - 1)].
	
	fixedSize _ aDescriptor fixedSize.
	varyingSize _ aDescriptor varyingSize.
	fixedRefs _ aDescriptor fixedRefs.
	varyingRefs _ aDescriptor varyingRefs.
	name _ aDescriptor className.
	
	self fixIndices.
	self calculateNameOffsets.! !

!Float methodsFor: '*goods' stamp: 'AB 3/11/2002 01:29'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 3; uint32: self asIEEE32BitWord ! !

!Float methodsFor: '*goods' stamp: 'avi 2/27/2004 23:19'!
goodsIsImmediateValue
	^ true! !

!Color class methodsFor: '*goods' stamp: 'jrp 9/27/2004 16:00'!
goodsFieldsToExclude

	^ #(cachedDepth cachedBitPattern)! !

TestCase subclass: #KKDBTest
	instanceVariableNames: 'dbOne dbTwo connOne connTwo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Test'!

!KKDBTest commentStamp: 'rbb 10/31/2003 16:38' prior: 0!
Avi: ok, well, should also test conflicts,
brian: 3 tests, 3 pass, and a tearDown that cleans up
Avi: test that changes get picked up,
brian: right, so use two connection and test locking and conficts
Avi: test storing various kinds of objects (for example Form would break right now)
Avi: test locking, yeah, although that's a pain when it fails
Avi: almost all of these should be using two conns,
Avi: because otherwise you're not really testing reading back
brian: ok, so have a testDate, testCollection, testForm, testStream, etc.
Avi: sure...
!

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 2/25/2004 02:25'!
testRefreshRoot
	dbOne root at: 'x' put: 1.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'x') = 1.
	dbTwo root at: 'y' put: 3.
	dbTwo commit.
	self assert: dbOne root size = 1.
	dbOne refresh.
	self assert: dbOne root size = 2.! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'rbb 10/31/2003 16:51'!
tearDown
	! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'rbb 10/31/2003 16:16'!
testTransactions
	" testNode1 should be an OrderedCollection"
	| dbOneNode1 dbTwoNode1 |
	dbOneNode1 := dbOne root at: 'TestNode1' ifAbsentPut: [OrderedCollection new].
	dbOne commit.
	dbTwo refresh.
	dbTwoNode1 := dbTwo root at: 'TestNode1'.
	
	dbOneNode1 reset.
	self assert: dbOneNode1 isEmpty.
	(1 to: 10) do: [:i | dbOneNode1 add: i].
	dbOne commit.
	dbTwo refresh.
	self assert: dbTwoNode1 asArray = #(1 2 3 4 5 6 7 8 9 10).
	
	dbOneNode1 reset.
	(11 to: 20) do: [:i | dbOneNode1 add: i].
	dbOne rollback.
	dbTwo refresh.
	self deny: dbTwoNode1 asArray =  #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20).
	! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:17'!
testSpecialObjects
	dbOne root at: 'test' put: dbOne.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'test') == dbTwo! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2003 23:37'!
testRootNode
	self assert: dbOne root = Dictionary new.
	dbOne root: #(23).
	dbOne commit.
	dbTwo refresh.
	self assert: dbTwo root = #(23).! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 4/3/2004 15:07'!
testRollbackExistingObject
	dbOne root: #(1 2 3).
	dbOne commit.
	dbTwo root at: 1 put: 0.
	dbTwo commit.
	dbOne refresh.
	dbOne rollback.
	self assert: dbOne root = dbTwo root! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 11/8/2003 00:10'!
setUp
	connOne := KKConnection hostname: (self dbHost) port: (self dbPort).
	connTwo := KKConnection hostname: (self dbHost) port: (self dbPort).
	dbOne := KKDatabase connection: connOne.
	dbOne root: Dictionary new; commit.
	dbTwo := KKDatabase connection: connTwo.! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 11/7/2003 23:34'!
testConnection
	self assert: connOne isConnected.
	self assert: connTwo isConnected! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 7/11/2004 11:56'!
testCharacters
	dbOne root at: 'c' put: $c.
	dbOne root at: 'd' put: $d.
	dbOne commit.
	dbTwo refresh.
	self assert: (dbTwo root at: 'c') = $c.
	self assert: (dbTwo root at: 'd') = $d.
	self assert: (String streamContents: [:s | s nextPut: (dbTwo root at: 'c'); nextPut: (dbTwo root at: 'd')]) = 'cd'.! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 8/6/2004 11:49'!
testClasses
	dbOne root at: 'dict' put: Dictionary.
	dbOne root at: 'oc' put: OrderedCollection.
	dbOne commit.
	self assert: (dbTwo root at: 'dict') = Dictionary.
	self assert: (dbTwo root at: 'oc') = OrderedCollection
! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 13:40'!
dbPort
	^ 6110! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'rbb 10/31/2003 11:05'!
dbHost
	^ 'localhost'! !

!KKDBTest methodsFor: 'as yet unclassified' stamp: 'avi 7/7/2004 11:12'!
testIdentitySet
	| set x y y2 x2 |
	set _ KKIdentitySet database: dbOne.
	x _ 1@1.
	y _ 2@2.
	set add: x.
	set add: y.
	self assert: (set includes: x).
	self assert: (set includes: y).
	self deny: (set includes: 1@1).
	set remove: x.
	self assert: (set includes: y).
	self deny: (set includes: x).
	dbOne root at: 'set' put: set.
"	dbOne root at: 'point' put: x."
	dbOne commit.
	dbTwo refresh.
"	x2 _ dbTwo root at: 'point'.
	self assert: x2 = x.
	self deny: x2 == x.
"	set _ dbTwo root at: 'set'.
	y2  _ set anyOne.
	self assert: y2 = y.
	self deny: y2 == y.
	self assert: (set includes: y2).
	self deny: (set includes: y).
	! !

!UndefinedObject methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!DateAndTime methodsFor: '*goods' stamp: 'avi 2/26/2004 16:56'!
goodsIsImmutable
	^ true! !

!Duration methodsFor: '*goods' stamp: 'avi 2/26/2004 16:57'!
goodsIsImmutable
	^ true! !

Notification subclass: #KKRequestKey
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKRequestKey methodsFor: 'as yet unclassified' stamp: 'avi 10/31/2003 12:17'!
defaultAction
	self error: 'No write handler'! !

!KKRequestKey methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:04'!
object: anObject
	object _ anObject! !

!KKRequestKey methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:04'!
object
	^ object! !

Notification subclass: #KKRequestObject
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Metadata'!

!KKRequestObject methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:04'!
key: aKey
	key _ aKey! !

!KKRequestObject methodsFor: 'as yet unclassified' stamp: 'AB 3/18/2002 18:04'!
key
	^ key! !

!KKRequestObject methodsFor: 'as yet unclassified' stamp: 'avi 10/31/2003 12:17'!
defaultAction
	self error: 'No read handler'! !

!Boolean methodsFor: '*goods' stamp: 'AB 3/11/2002 01:31'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 2; next: 3 put: 0; boolean: self! !

!Boolean methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!Boolean class methodsFor: '*goods' stamp: 'AB 3/10/2002 17:04'!
goodsDescriptor
	self error: 'Cannot store immediate values as references'	! !

!Symbol class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:33'!
goodsDescriptorClass 
	^ KKSymbolDescriptor! !

!SmallInteger class methodsFor: '*goods' stamp: 'AB 3/10/2002 17:04'!
goodsDescriptor
	self error: 'Cannot store immediate values as references'	! !

!SmallInteger methodsFor: '*goods' stamp: 'avi 2/27/2004 23:18'!
goodsIsImmediateValue
	^ true! !

!SmallInteger methodsFor: '*goods' stamp: 'AB 3/13/2002 00:36'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 1; nextInt32Put: self.
	! !

!Class class methodsFor: '*goods' stamp: 'rbb 8/6/2004 11:56'!
goodsDescriptorClass
	^ KKMetaclassDescriptor
! !

ProtoObject subclass: #KKObjectProxy
	instanceVariableNames: 'assoc database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Database'!

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2003 18:56'!
xxxObject
	assoc value ifNil: [assoc value: (database at: assoc key)].
	^ assoc value! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2003 18:56'!
isInMemory
	^ assoc value notNil! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2003 18:57'!
xxxKey: oid
	assoc _ WeakValueAssociation key: oid value: nil.! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 15:15'!
xxxDatabase: aDatabase
	database _ aDatabase! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/27/2003 18:56'!
xxxKey
	^ assoc key! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 3/1/2004 14:18'!
isMorph
	"satisfy CommandHistory"
	^ false! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 2/27/2004 01:23'!
goodsIsImmediateValue
	^ false! !

!KKObjectProxy methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 15:16'!
doesNotUnderstand: aMessage
	^ self xxxObject perform: aMessage selector withArguments: aMessage arguments! !

!KKObjectProxy class methodsFor: 'as yet unclassified' stamp: 'avi 10/26/2003 15:17'!
database: aDatabase key: key
	^ self basicNew
		xxxDatabase: aDatabase;
		xxxKey: key! !

!Character methodsFor: '*goods' stamp: 'avi 7/11/2004 11:58'!
goodsWriteTaggedOn: aStream
	aStream nextPut: 5; nextInt32Put: value
	! !

!Character methodsFor: '*goods' stamp: 'avi 7/11/2004 11:58'!
goodsIsImmediateValue
	^ true! !

!String methodsFor: '*goods' stamp: 'avi 2/26/2004 16:56'!
goodsIsImmutable
	^ true! !

!String class methodsFor: '*goods' stamp: 'AB 3/8/2002 15:29'!
goodsDescriptorClass 
	^ KKStringDescriptor! !

!Metaclass methodsFor: '*goods' stamp: 'avi 8/6/2004 11:47'!
goodsDescriptor
	| descriptor |
	descriptor _  KKMetaclassDescriptor new className: 'Class'.
	descriptor addField: String goodsVariableFieldDescriptor.
	^ descriptor
! !

!ObjectExplorerWrapper methodsFor: '*goods' stamp: 'avi 10/31/2003 11:50'!
contents

	(item respondsTo: #explorerContents) ifTrue: [^item explorerContents].
	"For all others, show named vars first, then indexed vars"
	^(item yourClass allInstVarNames asOrderedCollection withIndexCollect: [:each :index |
		self class
			with: (item instVarAt: index)
			name: each
			model: item]) ,
	((1 to: item basicSize) collect: [:index |
		self class
			with: (item basicAt: index)
			name: index printString
			model: item])! !

!Set class methodsFor: '*goods' stamp: 'avi 10/25/2003 03:21'!
arrayDescriptor
	^ KKVariableFieldContainer referenceField! !

!Set class methodsFor: '*goods' stamp: 'avi 10/25/2003 03:19'!
tallyDescriptor
	^ KKSingleFieldContainer intField! !

Set subclass: #KKIdentitySet
	instanceVariableNames: 'database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GOODS-Collections'!

!KKIdentitySet methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:27'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	start _ (database keyForObject: anObject) \\ array size + 1.
	finish _ array size.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element _ array at: index) == nil or: [element == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element _ array at: index) == nil or: [element == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!KKIdentitySet methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:24'!
initializeWithDatabase: aKKDatabase
	database _ aKKDatabase! !

!KKIdentitySet methodsFor: 'as yet unclassified' stamp: 'avi 7/10/2004 02:01'!
species
	^ IdentitySet! !

!KKIdentitySet class methodsFor: 'as yet unclassified' stamp: 'avi 7/6/2004 12:24'!
database: aKKDatabase
	^ self new initializeWithDatabase: aKKDatabase! !
